/*
* MySerial.cpp
* Visual StudioŃVAʐMT|[gNXłB
* VC++CLRvWFNgC#VB痘p\łB
* ĂĂȂłAVAʐMNXC#ōǂȂB
* 
* K. Morishita @ Kumamoto-Univ. 2012
* 
* 201212/22 oCî肪ł悤ɉBFIFOobt@t̂łԂƂ₷ȂB
*           string^ւ̌^ϊł́AftHgłeuc-jpŃGR[fBOĂ܂B
*           [U̓sɍ킹ătH[}bg͕ύXĂB
*           ȂAASCIIiAt@xbgƍŒ̋L̏Wj̒ʐMłΈӎKv܂B
*           ̓tH[}bgwł悤ɂłAΉ͖łB
*/
#include "StdAfx.h"
#include "MySerial.h"

// RXgN^
// |[g̏s܂
MySerial::MySerial(String^ com, int baudrate)
{
	this->port = gcnew SerialPort();
	this->port->PortName = com;
	this->port->BaudRate = baudrate;
	this->port->DataReceived += gcnew SerialDataReceivedEventHandler(this, &MySerial::DataReceivedHandler);// Ăяo֐o^BCX^X̋ʂƊ֐̋ʂ̗Bstatic֐Ȃ֐łǁB
	this->port->Open();
	this->size  = 300;
	this->buff  = gcnew array <Byte>(this->size);
	this->wp    = 0;
	this->rp    = 0;
}
// fXRXgN^
MySerial::~MySerial(void)
{

}
// Mf[^Ԃ
int MySerial::GetLength(void)
{
	int t = this->wp - this->rp;
	if(t < 0) t += this->size;
	return t;
}
// stringbytẽA[ւ̕ϊ
array<System::Byte>^ MySerial::StringToByteArray(String^ src, String^ name)
{
    if ( name == "" ) name = "euc-jp";

    System::Text::Encoding^ enc = System::Text::Encoding::GetEncoding(name);
    return enc->GetBytes(src);
}
// bytẽA[stringւ̕ϊ
String^ MySerial::ByteArrayToString(array<System::Byte>^ src, String^ name)
{
    if ( name == "" ) name = "euc-jp";

    System::Text::Encoding^ enc = System::Text::Encoding::GetEncoding(name);
    return enc->GetString(src);
}
// Mf[^ǂݍ
String^ MySerial::Read()
{
	String^ copybuff = "";
	int size = this->GetLength();
	
	if(size > 0)
	{
		array <Byte>^ copy  = gcnew array <Byte>(size);
		for(int i = 0; i < size; i++)
		{
			int t = (this->rp + 1) % this->size;
			copy[i] = this->buff[this->rp];
			if(t != this->wp)
				this->rp = t;
			else
				break;	// s邱Ƃ悤ƁAɂ܂
		}
		copybuff = this->ByteArrayToString(copy, "");
	}
	return copybuff;
}
// Mf[^ǂݍ
array <Byte>^ MySerial::ReadByte()
{
	array <Byte>^ copy = gcnew array <Byte>(0);
	int size = this->GetLength();
	
	if(size > 0)
	{
		copy  = gcnew array <Byte>(size);
		for(int i = 0; i < size; i++)
		{
			int t = (this->rp + 1) % this->size;
			copy[i] = this->buff[this->rp];
			if(t != this->wp)
				this->rp = t;
			else
				break;	// s邱Ƃ悤ƁAɂ܂
		}
	}
	return copy;
}
// M
void MySerial::Write(String^ msg)
{
	this->port->Write(msg);
	return;
}
// M
void MySerial::Write(array <Byte>^ sendBuff)
{
	this->port->Write(sendBuff, 0, sendBuff->Length);
	return;
}
// M sR[ht
void MySerial::WriteLine(String^ msg)
{
	this->port->WriteLine(msg);
	return;
}
// |[g
void MySerial::Close()
{
	this->port->Close();
}
// f[^M
void MySerial::DataReceivedHandler( Object^ sender, SerialDataReceivedEventArgs^ e)
{
	SerialPort^ sp = (SerialPort^)sender;
	int size = sp->BytesToRead;

	for(int k = 0; k < size; k++)
	{
		int t = (this->wp + 1) % this->size;
		this->buff[this->wp] = sp->ReadByte();
		if(t != this->rp) 
			this->wp = t;
		else
			break;
	}
}
